<?php
/**
 * Plugin Name: Dadevarzan WordPress facility plugin
 * Plugin URI: https://wordpress.org/plugins/dadevarzan-wp-facility
 * GitHub Plugin URI: https://github.com/dadevarzan/dadevarzan-wp-facility
 * Description: facility post type for wordpress
 * Version: 1.2.0
 * Author: Dadevarzan Team
 * Author URI: http://www.dadevarzan.com
 * Text Domain: dadevarzan-wp-facility
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
    die;
}

if ( !class_exists( 'dadevarzanWpFacility' ) ) {

    class dadevarzanWpFacility
    {

        public static function initialize()
        {

            add_action( 'plugins_loaded', 'dadevarzanWpFacility::load_text_domain' );
            add_action( 'init', 'dadevarzanWpFacility::add_post_type' );
            add_action( 'init', 'dadevarzanWpFacility::add_fields' );
            add_action('init', 'dadevarzanWpFacility::add_taxonomy');
            add_action('init', 'dadevarzanWpFacility::add_role_caps');
            add_action( 'plugins_loaded', 'dadevarzanWpFacility::load_templates' );

        }

        public static function add_post_type()
        {

            $labels = array(
                "name" => __('Facility', 'dadevarzan-wp-facility'),
                "singular_name" => __('Facility', 'dadevarzan-wp-facility'),
                "menu_name" => __('Facility', 'dadevarzan-wp-facility'),
                "all_items" => __('All Facility', 'dadevarzan-wp-facility'),
                "add_new" => __('Add Facility', 'dadevarzan-wp-facility'),
                "add_new_item" => __('Add New Facility', 'dadevarzan-wp-facility'),
            );

            $args = array(
                "label" => __('Facility', 'dadevarzan-wp-facility'),
                "labels" => $labels,
                "description" => "",
                "public" => true,
                "publicly_queryable" => true,
                "show_ui" => true,
                "show_in_rest" => true,
                "rest_base" => "",
				"show_in_nav_menus" => true,
                "has_archive" => true,
                "show_in_menu" => true,
                "exclude_from_search" => false,
                "hierarchical" => false,
                "rewrite" => array( "slug" => "facility", "with_front" => true ),
                "query_var" => true,
                "menu_icon" => "dashicons-image-filter",
                "supports" => array( "title", "excerpt", "editor", "thumbnail", "comments", "author" ),
                "capability_type" => array('facility', 'facilities'),
                "map_meta_cap" => true,
                "taxonomies" => array( "facility_category" ),
            );

            register_post_type( 'facility', $args );

        }

        public static function add_fields()
        {

            if( function_exists('acf_add_local_field_group') ):

                acf_add_local_field_group(array(
                    'key' => 'group_59ef1a797f196',
                    'title' => __('Facility', 'dadevarzan-wp-facility'),
                    'fields' => array(
                        array(
                            'key' => 'field_59ef1aac98917',
                            'label' => __('Facility Items', 'dadevarzan-wp-facility'),
                            'name' => 'dv_ftr_items',
                            'type' => 'repeater',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'collapsed' => '',
                            'min' => 0,
                            'max' => 0,
                            'layout' => 'row',
                            'button_label' => '',
                            'sub_fields' => array(
                                array(
                                    'key' => 'field_59ef1aee98918',
                                    'label' => __('Title', 'dadevarzan-wp-facility'),
                                    'name' => 'dv_ftr_title',
                                    'type' => 'text',
                                    'instructions' => '',
                                    'required' => 0,
                                    'conditional_logic' => 0,
                                    'wrapper' => array(
                                        'width' => '',
                                        'class' => '',
                                        'id' => '',
                                    ),
                                    'default_value' => '',
                                    'placeholder' => '',
                                    'prepend' => '',
                                    'append' => '',
                                    'maxlength' => '',
                                ),
                                array(
                                    'key' => 'field_59ef1b1098919',
                                    'label' => __('Icon', 'dadevarzan-wp-facility'),
                                    'name' => 'dv_ftr_icon',
                                    'type' => 'image',
                                    'instructions' => '',
                                    'required' => 0,
                                    'conditional_logic' => 0,
                                    'wrapper' => array(
                                        'width' => '',
                                        'class' => '',
                                        'id' => '',
                                    ),
                                    'return_format' => 'url',
                                    'preview_size' => 'full',
                                    'library' => 'all',
                                    'min_width' => '',
                                    'min_height' => '',
                                    'min_size' => '',
                                    'max_width' => '',
                                    'max_height' => '',
                                    'max_size' => '',
                                    'mime_types' => 'jpg,jpeg,png,gif',
                                ),
                            ),
                        ),
                        array(
                            'key' => 'field_59ef1dec7a570',
                            'label' => __('Gallery', 'dadevarzan-wp-facility'),
                            'name' => 'dv_ftr_gallery',
                            'type' => 'gallery',
                            'instructions' => '',
                            'required' => 1,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'min' => '',
                            'max' => '',
                            'insert' => 'append',
                            'library' => 'all',
                            'min_width' => '',
                            'min_height' => '',
                            'min_size' => '',
                            'max_width' => '',
                            'max_height' => '',
                            'max_size' => '',
                            'mime_types' => 'jpg,jpeg,gif,png',
                        ),
                        array(
                            'key' => 'field_59ef29a69a7ba',
                            'label' => __('3D Image', 'dadevarzan-wp-facility'),
                            'name' => 'dv_ftr_360_view',
                            'type' => 'wysiwyg',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'tabs' => 'text',
                            'toolbar' => 'basic',
                            'media_upload' => 1,
                            'delay' => 0,
                        ),
                        array(
                            'key' => 'field_5a2be0fd6214c',
                            'label' => __('Map position', 'dadevarzan-wp-facility'),
                            'name' => 'dv_ftr_googlemap',
                            'type' => 'google_map',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'center_lat' => '35.757549',
                            'center_lng' => '51.410033',
                            'zoom' => '',
                            'height' => 455,
                        ),
                    ),
                    'location' => array(
                        array(
                            array(
                                'param' => 'post_type',
                                'operator' => '==',
                                'value' => 'facility',
                            ),
                        ),
                    ),
                    'menu_order' => 0,
                    'position' => 'acf_after_title',
                    'style' => 'default',
                    'label_placement' => 'top',
                    'instruction_placement' => 'label',
                    'hide_on_screen' => '',
                    'active' => 1,
                    'description' => '',
                ));

            endif;

        }

        public static function add_taxonomy()
        {

            $labels = array(
                "name" => __('Facility Categories', 'dadevarzan-wp-facility'),
                "singular_name" => __('Facility Category', 'dadevarzan-wp-facility'),
            );

            $args = array(
                "label" => __('Facility Categories', 'dadevarzan-wp-facility'),
                "labels" => $labels,
                "public" => true,
                "hierarchical" => true,
                "show_ui" => true,
                "show_in_menu" => true,
                "show_in_nav_menus" => true,
                "query_var" => true,
                "rewrite" => array( 'slug' => 'facility_categories', 'with_front' => true, ),
                "show_in_nav_menus" => true,
                "show_admin_column" => true,
                "show_in_rest" => true,
                "rest_base" => "",
                "show_in_quick_edit" => true,
                'capabilities' => array(
                    'manage_terms' => 'manage_categories',
                    'edit_terms' => 'manage_categories',
                    'delete_terms' => 'manage_categories',
                    'assign_term' => 'manage_categories',
                    'assign_terms' => 'manage_categories',
                ),
            );

            register_taxonomy( 'facility_category', array( 'facility' ), $args );

        }

        public static function add_role_caps()
        {

            // Add the roles you'd like to administer the custom post types
            $roles = array('wpseo_editor', 'wpseo_manager', 'shop_manager', 'editor', 'administrator');

            // Loop through each role and assign capabilities
            foreach($roles as $the_role) {

                $role = get_role($the_role);

                if ( empty($role) ) {
                    continue;
                }

                $role->add_cap( 'read' );
                $role->add_cap( 'read_facility' );
                $role->add_cap( 'edit_facility' );
                $role->add_cap( 'edit_facilities' );
                $role->add_cap( 'edit_private_facilities' );
                $role->add_cap( 'edit_published_facilities' );
                $role->add_cap( 'edit_others_facilities' );
                $role->add_cap( 'delete_facility' );
                $role->add_cap( 'delete_facilities' );
                $role->add_cap( 'delete_private_facilities' );
                $role->add_cap( 'delete_published_facilities' );
                $role->add_cap( 'delete_others_facilities' );
                $role->add_cap( 'publish_facilities' );
                $role->add_cap( 'read_private_facilities' );

            }

        }

        public static function load_templates() {

            /**
             * Return if the builder isn't installed or if the current
             * version doesn't support registering templates.
             */
            if ( ! class_exists( 'FLBuilder' ) || ! method_exists( 'FLBuilder', 'register_templates' ) ) {
                return;
            }

            $layoutTemplatePath = plugin_dir_path( __FILE__ ) . 'data/templates.dat';
            if ( file_exists( $layoutTemplatePath ) && class_exists( 'FLThemeBuilder' ) ) {
                FLBuilder::register_templates( $layoutTemplatePath, array('group' => 'facility'));
            }

        }

        public static function load_text_domain()
        {
            load_plugin_textdomain( 'dadevarzan-wp-facility', FALSE, basename( dirname( __FILE__ ) ) . '/languages'  );
        }
    }

    dadevarzanWpFacility::initialize();

}
